﻿Imports System.ComponentModel
Imports System.Windows.Forms
Imports _DatasetTemplate.dts_DatasetTemplate
Imports Misc

Public Class frm_DatasetTemplate

	Private WithEvents _Conv As New ComplexConverter

	Public Sub New()
		InitializeComponent()
		If NotifyPropertyChanged.IsInDesignMode Then Return
		spCopyTemplate.Dispose() ' braucht man nur zur Designzeit
		ControlStyling.StyleControls(Me)
		_Conv.ApplyDataString(My.Settings.StartupData) 'Settings anwenden
		AddHandler Me.FormClosed, Sub(s, e) My.Settings.StartupData = _Conv.CreateDataString 'Settings rückspeichern
		Dts.DataFile("..\..\DataStuff\dts_DatasetTemplate.xml").Register(Me).Fill
		AutoMenu.Create(AddressOf CreateData, AddressOf Test2)("Save", Sub() Dts.Save(Me)).Nop
	End Sub

	Private Sub CreateData()
		For i = 0 To 30
			Dts.Kunde.AddKundeRow($"Name_{i}", $"Vorname_{i}", #9/11/2001#.AddYears(i))
		Next
	End Sub
	Private Sub Test()
	End Sub
	Private Sub Test2()
	End Sub


	Private Sub OnConvert(sender As Object, e As ComplexConverter.EventArg) Handles _Conv.Convert
		'Settings anwenden/rückspeichern
		e.ConvertValue(Me.Bounds)
		'Umständlichkeit, weil cktFilter.TextChange ändert den Checkstate.
		Dim ckState = cktFilter.Checkstate
		Dim ctls = New GetChilds(Of Control)(Function(c) c.Controls).AllAsList(Me)
		For Each ctl In New GetChilds(Of Control)(Function(c) c.Controls).AllAsList(Me)
			Dim dgv = TryCast(ctl, DataGridView)
			If dgv.NotNull Then
				For Each col As DataGridViewColumn In dgv.Columns
					e.ConvertValue(col.Width)
				Next
				Continue For
			End If
			Dim szPnl = TryCast(ctl, SizerPanel)
			If szPnl.NotNull Then
				For Each c As Control In szPnl.Controls
					If Not szPnl.GetIsFillControl(c) Then e.ConvertValue(c.Bounds)
				Next
				Continue For
			End If
			If TypeOf (ctl) Is TextBoxBase Then
				If ctl.DataBindings("Text") Is Nothing Then e.ConvertValue(ctl.Text)
				Continue For
			End If
		Next
		e.ConvertValue(ckState) 'Umständlichkeit
		cktFilter.Checkstate = ckState
	End Sub

End Class